package ij2x.util;

import java.awt.Dimension;
import java.awt.Image;
import java.awt.Insets;
import java.awt.event.ActionListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class BorderlessButton {

    private static ActionListener actionPerformed=null ;
    private static MouseListener mouseListener=null ;
    private static MouseMotionListener mouseMotionListener=null ;

    public static JButton createButton(
                            ActionListener actionpanel
                              , MouseListener mouselistenerpanel
                                , MouseMotionListener mousemotionlistenerpanel
                                       , JButton action
                                         , String tooltip
                                           , Image[] image){
         action = new JButton();
           action.setToolTipText(tooltip);
            action.addActionListener(actionpanel);
                action.addMouseListener(mouselistenerpanel);
            action.addMouseMotionListener(mousemotionlistenerpanel);
           setBorderlessButton(action);
          if(image != null){
              setIcon(action, image);
          }
    return action;
    }

    public static JButton createButton(
                                    Object objectListener
                                       , JButton action
                                         , String tooltip
                                           , Image[] image){

        if(objectListener instanceof ActionListener){
            actionPerformed = (ActionListener) objectListener;
        }
         if(objectListener instanceof MouseListener){
             mouseListener = (MouseListener) objectListener;
         }
        if(objectListener instanceof MouseMotionListener){
            mouseMotionListener = (MouseMotionListener) objectListener;
        }
         action = new JButton();
           action.setToolTipText(tooltip);
             action.addActionListener(actionPerformed);
              action.addMouseListener(mouseListener);
               action.addMouseMotionListener(mouseMotionListener);
               setBorderlessButton(action);
             if(image != null){
                 setIcon(action, image);
             }
    return action;
    }


    public static void setIcon(JButton action, Image[] image){
          action.setIcon(new ImageIcon(image[0]));
            action.setRolloverIcon(new ImageIcon(image[1]));
          action.setPressedIcon(new ImageIcon(image[2]));
    	/*ImageIcon[] icon = new ImageIcon[image.length];
    	for(int i=0; i < image.length ; i++){
    		switch(i){
    		case 0: {icon[i]=new ImageIcon(image[i]);
             action.setIcon(icon[i]);}
    		case 1: {icon[i]=new ImageIcon(image[i]);
             action.setRolloverIcon(icon[i]);}
    		case 2: {icon[i]=new ImageIcon(image[i]);
             action.setPressedIcon(icon[i]);}
    	    }
        }*/
    }

    static void setButtonDim(JButton action, Dimension maxDim, Dimension preDim, Dimension minDim){
      action.setMaximumSize(maxDim);
      action.setPreferredSize(preDim);
      action.setMinimumSize(minDim);
    }
   static void setBorderlessButton(JButton button){
      button.setMargin(new Insets(0, 0, 0, 0));
      button.setBorderPainted(false);
      button.setContentAreaFilled(false);
      button.setFocusPainted(false);
    }



}
